Package org.apache.commons.compress.compressors.lz77support

# Class Parameters

java.lang.Object
org.apache.commons.compress.compressors.lz77support.Parameters

public final class Parameters extends Object
Parameters of the `compressor`.

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `static class`
  `Parameters.Builder`
  Builder for `Parameters` instances.

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final int`
  `TRUE_MIN_BACK_REFERENCE_LENGTH`
  The hard-coded absolute minimal length of a back-reference.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static Parameters.Builder`
  `builder(int windowSize)`
  Initializes the builder for the compressor's parameters with a `minBackReferenceLength` of 3 and `max*Length` equal to `windowSize - 1`.
  `boolean`
  `getLazyMatching()`
  Gets whether to perform lazy matching.
  `int`
  `getLazyMatchingThreshold()`
  Gets the threshold for lazy matching.
  `int`
  `getMaxBackReferenceLength()`
  Gets the maximal length of a back-reference found.
  `int`
  `getMaxCandidates()`
  Gets the maximum number of back-reference candidates to consider.
  `int`
  `getMaxLiteralLength()`
  Gets the maximal length of a literal block.
  `int`
  `getMaxOffset()`
  Gets the maximal offset of a back-reference found.
  `int`
  `getMinBackReferenceLength()`
  Gets the minimal length of a back-reference found.
  `int`
  `getNiceBackReferenceLength()`
  Gets the length of a back-reference that is considered nice enough to stop searching for longer ones.
  `int`
  `getWindowSize()`
  Gets the size of the sliding window - this determines the maximum offset a back-reference can take.

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Field Details

  - ### TRUE_MIN_BACK_REFERENCE_LENGTH

    public static final int TRUE_MIN_BACK_REFERENCE_LENGTH
    The hard-coded absolute minimal length of a back-reference.
    See Also:
      - Constant Field Values

- ## Method Details

  - ### builder

    public static Parameters.Builder builder(int windowSize)
    Initializes the builder for the compressor's parameters with a `minBackReferenceLength` of 3 and `max*Length` equal to `windowSize - 1`.

    It is recommended to not use this method directly but rather tune a pre-configured builder created by a format specific factory like `SnappyCompressorOutputStream.createParameterBuilder(int)`.

    Parameters:
      `windowSize` - the size of the sliding window - this determines the maximum offset a back-reference can take. Must be a power of two.
    Returns:
      a builder configured for the given window size
    Throws:
      `IllegalArgumentException` - if windowSize is not a power of two.

  - ### getLazyMatching

    public boolean getLazyMatching()
    Gets whether to perform lazy matching.
    Returns:
      whether to perform lazy matching

  - ### getLazyMatchingThreshold

    public int getLazyMatchingThreshold()
    Gets the threshold for lazy matching.
    Returns:
      the threshold for lazy matching

  - ### getMaxBackReferenceLength

    public int getMaxBackReferenceLength()
    Gets the maximal length of a back-reference found.
    Returns:
      the maximal length of a back-reference found

  - ### getMaxCandidates

    public int getMaxCandidates()
    Gets the maximum number of back-reference candidates to consider.
    Returns:
      the maximum number of back-reference candidates to consider

  - ### getMaxLiteralLength

    public int getMaxLiteralLength()
    Gets the maximal length of a literal block.
    Returns:
      the maximal length of a literal block

  - ### getMaxOffset

    public int getMaxOffset()
    Gets the maximal offset of a back-reference found.
    Returns:
      the maximal offset of a back-reference found

  - ### getMinBackReferenceLength

    public int getMinBackReferenceLength()
    Gets the minimal length of a back-reference found.
    Returns:
      the minimal length of a back-reference found

  - ### getNiceBackReferenceLength

    public int getNiceBackReferenceLength()
    Gets the length of a back-reference that is considered nice enough to stop searching for longer ones.
    Returns:
      the length of a back-reference that is considered nice enough to stop searching

  - ### getWindowSize

    public int getWindowSize()
    Gets the size of the sliding window - this determines the maximum offset a back-reference can take.
    Returns:
      the size of the sliding window